<center><a href="cholesky.c">Actual source code: cholesky.c</a></center><br>

<html>
<head>
<title></title>
<meta name="generator" content="c2html 0.9.5">
<meta name="date" content="2007-03-29T00:28:50+00:00">
</head>

<body bgcolor="#FFFFFF">
<pre width="80"><a name="line1">  1: </a><strong><font color="#228B22">#define PETSCKSP_DLL</font></strong>

<a name="line3">  3: </a><font color="#B22222">/*</font>
<a name="line4">  4: </a><font color="#B22222">   Defines a direct factorization preconditioner for any <A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> implementation</font>
<a name="line5">  5: </a><font color="#B22222">   Note: this need not be consided a preconditioner since it supplies</font>
<a name="line6">  6: </a><font color="#B22222">         a direct solver.</font>
<a name="line7">  7: </a><font color="#B22222">*/</font>
<a name="line8"> 8: </a> #include <A href="../../../../../../include/private/pcimpl.h.html">private/pcimpl.h</A>

<a name="line10"> 10: </a><font color="#4169E1">typedef</font> <font color="#4169E1">struct</font> {
<a name="line11"> 11: </a>  <A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>             fact;             <font color="#B22222">/* factored matrix */</font>
<a name="line12"> 12: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>       actualfill;       <font color="#B22222">/* actual fill in factor */</font>
<a name="line13"> 13: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>      inplace;          <font color="#B22222">/* flag indicating in-place factorization */</font>
<a name="line14"> 14: </a>  <A href="../../../../../../docs/manualpages/IS/IS.html#IS">IS</A>              row,col;          <font color="#B22222">/* index sets used for reordering */</font>
<a name="line15"> 15: </a>  <A href="../../../../../../docs/manualpages/Mat/MatOrderingType.html#MatOrderingType">MatOrderingType</A> ordering;         <font color="#B22222">/* matrix ordering */</font>
<a name="line16"> 16: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>      reuseordering;    <font color="#B22222">/* reuses previous reordering computed */</font>
<a name="line17"> 17: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>      reusefill;        <font color="#B22222">/* reuse fill from previous Cholesky */</font>
<a name="line18"> 18: </a>  <A href="../../../../../../docs/manualpages/Mat/MatFactorInfo.html#MatFactorInfo">MatFactorInfo</A>   info;
<a name="line19"> 19: </a>} PC_Cholesky;

<a name="line24"> 24: </a><strong><font color="#4169E1"><a name="PCFactorSetZeroPivot_Cholesky"></a><A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  PCFactorSetZeroPivot_Cholesky(<A href="../../../../../../docs/manualpages/PC/PC.html#PC">PC</A> pc,<A href="../../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> z)</font></strong>
<a name="line25"> 25: </a>{
<a name="line26"> 26: </a>  PC_Cholesky *ch;

<a name="line29"> 29: </a>  ch                 = (PC_Cholesky*)pc-&gt;data;
<a name="line30"> 30: </a>  ch-&gt;info.zeropivot = z;
<a name="line31"> 31: </a>  <font color="#4169E1">return</font>(0);
<a name="line32"> 32: </a>}

<a name="line38"> 38: </a><strong><font color="#4169E1"><a name="PCFactorSetShiftNonzero_Cholesky"></a><A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  PCFactorSetShiftNonzero_Cholesky(<A href="../../../../../../docs/manualpages/PC/PC.html#PC">PC</A> pc,<A href="../../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> shift)</font></strong>
<a name="line39"> 39: </a>{
<a name="line40"> 40: </a>  PC_Cholesky *dir;

<a name="line43"> 43: </a>  dir = (PC_Cholesky*)pc-&gt;data;
<a name="line44"> 44: </a>  <font color="#4169E1">if</font> (shift == (<A href="../../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>) <A href="../../../../../../docs/manualpages/Sys/PETSC_DECIDE.html#PETSC_DECIDE">PETSC_DECIDE</A>) {
<a name="line45"> 45: </a>    dir-&gt;info.shiftnz = 1.e-12;
<a name="line46"> 46: </a>  } <font color="#4169E1">else</font> {
<a name="line47"> 47: </a>    dir-&gt;info.shiftnz = shift;
<a name="line48"> 48: </a>  }
<a name="line49"> 49: </a>  <font color="#4169E1">return</font>(0);
<a name="line50"> 50: </a>}

<a name="line56"> 56: </a><strong><font color="#4169E1"><a name="PCFactorSetShiftPd_Cholesky"></a><A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  PCFactorSetShiftPd_Cholesky(<A href="../../../../../../docs/manualpages/PC/PC.html#PC">PC</A> pc,<A href="../../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A> shift)</font></strong>
<a name="line57"> 57: </a>{
<a name="line58"> 58: </a>  PC_Cholesky *dir;
<a name="line59"> 59: </a>
<a name="line61"> 61: </a>  dir = (PC_Cholesky*)pc-&gt;data;
<a name="line62"> 62: </a>  <font color="#4169E1">if</font> (shift) {
<a name="line63"> 63: </a>    dir-&gt;info.shift_fraction = 0.0;
<a name="line64"> 64: </a>    dir-&gt;info.shiftpd = 1.0;
<a name="line65"> 65: </a>  } <font color="#4169E1">else</font> {
<a name="line66"> 66: </a>    dir-&gt;info.shiftpd = 0.0;
<a name="line67"> 67: </a>  }
<a name="line68"> 68: </a>  <font color="#4169E1">return</font>(0);
<a name="line69"> 69: </a>}

<a name="line75"> 75: </a><strong><font color="#4169E1"><a name="PCFactorSetReuseOrdering_Cholesky"></a><A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  PCFactorSetReuseOrdering_Cholesky(<A href="../../../../../../docs/manualpages/PC/PC.html#PC">PC</A> pc,<A href="../../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A> flag)</font></strong>
<a name="line76"> 76: </a>{
<a name="line77"> 77: </a>  PC_Cholesky *lu;
<a name="line78"> 78: </a>
<a name="line80"> 80: </a>  lu               = (PC_Cholesky*)pc-&gt;data;
<a name="line81"> 81: </a>  lu-&gt;reuseordering = flag;
<a name="line82"> 82: </a>  <font color="#4169E1">return</font>(0);
<a name="line83"> 83: </a>}

<a name="line89"> 89: </a><strong><font color="#4169E1"><a name="PCFactorSetReuseFill_Cholesky"></a><A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  PCFactorSetReuseFill_Cholesky(<A href="../../../../../../docs/manualpages/PC/PC.html#PC">PC</A> pc,<A href="../../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A> flag)</font></strong>
<a name="line90"> 90: </a>{
<a name="line91"> 91: </a>  PC_Cholesky *lu;
<a name="line92"> 92: </a>
<a name="line94"> 94: </a>  lu = (PC_Cholesky*)pc-&gt;data;
<a name="line95"> 95: </a>  lu-&gt;reusefill = flag;
<a name="line96"> 96: </a>  <font color="#4169E1">return</font>(0);
<a name="line97"> 97: </a>}

<a name="line102">102: </a><strong><font color="#4169E1"><a name="PCSetFromOptions_Cholesky"></a>static <A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> PCSetFromOptions_Cholesky(<A href="../../../../../../docs/manualpages/PC/PC.html#PC">PC</A> pc)</font></strong>
<a name="line103">103: </a>{
<a name="line104">104: </a>  PC_Cholesky    *lu = (PC_Cholesky*)pc-&gt;data;
<a name="line106">106: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>     flg;
<a name="line107">107: </a>  char           tname[256];
<a name="line108">108: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscFList.html#PetscFList">PetscFList</A>     ordlist;
<a name="line109">109: </a>
<a name="line111">111: </a>  <A href="../../../../../../docs/manualpages/MatOrderings/MatOrderingRegisterAll.html#MatOrderingRegisterAll">MatOrderingRegisterAll</A>(<A href="../../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line112">112: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscOptionsHead.html#PetscOptionsHead">PetscOptionsHead</A>(<font color="#666666">"Cholesky options"</font>);
<a name="line113">113: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscOptionsName.html#PetscOptionsName">PetscOptionsName</A>(<font color="#666666">"-pc_factor_in_place"</font>,<font color="#666666">"Form Cholesky in the same memory as the matrix"</font>,<font color="#666666">"<A href="../../../../../../docs/manualpages/PC/PCFactorSetUseInPlace.html#PCFactorSetUseInPlace">PCFactorSetUseInPlace</A>"</font>,&amp;flg);
<a name="line114">114: </a>  <font color="#4169E1">if</font> (flg) {
<a name="line115">115: </a>    <A href="../../../../../../docs/manualpages/PC/PCFactorSetUseInPlace.html#PCFactorSetUseInPlace">PCFactorSetUseInPlace</A>(pc);
<a name="line116">116: </a>  }
<a name="line117">117: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscOptionsReal.html#PetscOptionsReal">PetscOptionsReal</A>(<font color="#666666">"-pc_factor_fill"</font>,<font color="#666666">"Expected non-zeros in Cholesky/non-zeros in matrix"</font>,<font color="#666666">"<A href="../../../../../../docs/manualpages/PC/PCFactorSetFill.html#PCFactorSetFill">PCFactorSetFill</A>"</font>,lu-&gt;info.fill,&amp;lu-&gt;info.fill,0);
<a name="line118">118: </a>
<a name="line119">119: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscOptionsName.html#PetscOptionsName">PetscOptionsName</A>(<font color="#666666">"-pc_factor_reuse_fill"</font>,<font color="#666666">"Use fill from previous factorization"</font>,<font color="#666666">"<A href="../../../../../../docs/manualpages/PC/PCFactorSetReuseFill.html#PCFactorSetReuseFill">PCFactorSetReuseFill</A>"</font>,&amp;flg);
<a name="line120">120: </a>  <font color="#4169E1">if</font> (flg) {
<a name="line121">121: </a>    <A href="../../../../../../docs/manualpages/PC/PCFactorSetReuseFill.html#PCFactorSetReuseFill">PCFactorSetReuseFill</A>(pc,<A href="../../../../../../docs/manualpages/Sys/PETSC_TRUE.html#PETSC_TRUE">PETSC_TRUE</A>);
<a name="line122">122: </a>  }
<a name="line123">123: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscOptionsName.html#PetscOptionsName">PetscOptionsName</A>(<font color="#666666">"-pc_factor_reuse_ordering"</font>,<font color="#666666">"Reuse ordering from previous factorization"</font>,<font color="#666666">"<A href="../../../../../../docs/manualpages/PC/PCFactorSetReuseOrdering.html#PCFactorSetReuseOrdering">PCFactorSetReuseOrdering</A>"</font>,&amp;flg);
<a name="line124">124: </a>  <font color="#4169E1">if</font> (flg) {
<a name="line125">125: </a>    <A href="../../../../../../docs/manualpages/PC/PCFactorSetReuseOrdering.html#PCFactorSetReuseOrdering">PCFactorSetReuseOrdering</A>(pc,<A href="../../../../../../docs/manualpages/Sys/PETSC_TRUE.html#PETSC_TRUE">PETSC_TRUE</A>);
<a name="line126">126: </a>  }
<a name="line127">127: </a>
<a name="line128">128: </a>  MatGetOrderingList(&amp;ordlist);
<a name="line129">129: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscOptionsList.html#PetscOptionsList">PetscOptionsList</A>(<font color="#666666">"-pc_factor_mat_ordering_type"</font>,<font color="#666666">"Reordering to reduce nonzeros in Cholesky"</font>,<font color="#666666">"<A href="../../../../../../docs/manualpages/PC/PCFactorSetMatOrdering.html#PCFactorSetMatOrdering">PCFactorSetMatOrdering</A>"</font>,ordlist,lu-&gt;ordering,tname,256,&amp;flg);
<a name="line130">130: </a>  <font color="#4169E1">if</font> (flg) {
<a name="line131">131: </a>    <A href="../../../../../../docs/manualpages/PC/PCFactorSetMatOrdering.html#PCFactorSetMatOrdering">PCFactorSetMatOrdering</A>(pc,tname);
<a name="line132">132: </a>  }
<a name="line133">133: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscOptionsName.html#PetscOptionsName">PetscOptionsName</A>(<font color="#666666">"-pc_factor_shift_nonzero"</font>,<font color="#666666">"Shift added to diagonal"</font>,<font color="#666666">"<A href="../../../../../../docs/manualpages/PC/PCFactorSetShiftNonzero.html#PCFactorSetShiftNonzero">PCFactorSetShiftNonzero</A>"</font>,&amp;flg);
<a name="line134">134: </a>  <font color="#4169E1">if</font> (flg) {
<a name="line135">135: </a>    <A href="../../../../../../docs/manualpages/PC/PCFactorSetShiftNonzero.html#PCFactorSetShiftNonzero">PCFactorSetShiftNonzero</A>(pc,(<A href="../../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>) <A href="../../../../../../docs/manualpages/Sys/PETSC_DECIDE.html#PETSC_DECIDE">PETSC_DECIDE</A>);
<a name="line136">136: </a>  }
<a name="line137">137: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscOptionsReal.html#PetscOptionsReal">PetscOptionsReal</A>(<font color="#666666">"-pc_factor_shift_nonzero"</font>,<font color="#666666">"Shift added to diagonal"</font>,<font color="#666666">"<A href="../../../../../../docs/manualpages/PC/PCFactorSetShiftNonzero.html#PCFactorSetShiftNonzero">PCFactorSetShiftNonzero</A>"</font>,lu-&gt;info.shiftnz,&amp;lu-&gt;info.shiftnz,0);
<a name="line138">138: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscOptionsName.html#PetscOptionsName">PetscOptionsName</A>(<font color="#666666">"-pc_factor_shift_positive_definite"</font>,<font color="#666666">"Manteuffel shift applied to diagonal"</font>,<font color="#666666">"<A href="../../../../../../docs/manualpages/PC/PCFactorSetShiftPd.html#PCFactorSetShiftPd">PCFactorSetShiftPd</A>"</font>,&amp;flg);
<a name="line139">139: </a>  <font color="#4169E1">if</font> (flg) {
<a name="line140">140: </a>    <A href="../../../../../../docs/manualpages/PC/PCFactorSetShiftPd.html#PCFactorSetShiftPd">PCFactorSetShiftPd</A>(pc,<A href="../../../../../../docs/manualpages/Sys/PETSC_TRUE.html#PETSC_TRUE">PETSC_TRUE</A>);
<a name="line141">141: </a>  }
<a name="line142">142: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscOptionsReal.html#PetscOptionsReal">PetscOptionsReal</A>(<font color="#666666">"-pc_factor_zeropivot"</font>,<font color="#666666">"Pivot is considered zero if less than"</font>,<font color="#666666">"<A href="../../../../../../docs/manualpages/PC/PCFactorSetZeroPivot.html#PCFactorSetZeroPivot">PCFactorSetZeroPivot</A>"</font>,lu-&gt;info.zeropivot,&amp;lu-&gt;info.zeropivot,0);

<a name="line144">144: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscOptionsTail.html#PetscOptionsTail">PetscOptionsTail</A>();
<a name="line145">145: </a>  <font color="#4169E1">return</font>(0);
<a name="line146">146: </a>}

<a name="line150">150: </a><strong><font color="#4169E1"><a name="PCView_Cholesky"></a>static <A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> PCView_Cholesky(<A href="../../../../../../docs/manualpages/PC/PC.html#PC">PC</A> pc,<A href="../../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A> viewer)</font></strong>
<a name="line151">151: </a>{
<a name="line152">152: </a>  PC_Cholesky    *lu = (PC_Cholesky*)pc-&gt;data;
<a name="line154">154: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>     iascii,isstring;
<a name="line155">155: </a>
<a name="line157">157: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscTypeCompare.html#PetscTypeCompare">PetscTypeCompare</A>((<A href="../../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)viewer,PETSC_VIEWER_ASCII,&amp;iascii);
<a name="line158">158: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscTypeCompare.html#PetscTypeCompare">PetscTypeCompare</A>((<A href="../../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)viewer,PETSC_VIEWER_STRING,&amp;isstring);
<a name="line159">159: </a>  <font color="#4169E1">if</font> (iascii) {
<a name="line160">160: </a>
<a name="line161">161: </a>    <font color="#4169E1">if</font> (lu-&gt;inplace) {<A href="../../../../../../docs/manualpages/Viewer/PetscViewerASCIIPrintf.html#PetscViewerASCIIPrintf">PetscViewerASCIIPrintf</A>(viewer,<font color="#666666">"  Cholesky: in-place factorization\n"</font>);}
<a name="line162">162: </a>    <font color="#4169E1">else</font>             {<A href="../../../../../../docs/manualpages/Viewer/PetscViewerASCIIPrintf.html#PetscViewerASCIIPrintf">PetscViewerASCIIPrintf</A>(viewer,<font color="#666666">"  Cholesky: out-of-place factorization\n"</font>);}
<a name="line163">163: </a>    <A href="../../../../../../docs/manualpages/Viewer/PetscViewerASCIIPrintf.html#PetscViewerASCIIPrintf">PetscViewerASCIIPrintf</A>(viewer,<font color="#666666">"    matrix ordering: %s\n"</font>,lu-&gt;ordering);
<a name="line164">164: </a>    <font color="#4169E1">if</font> (lu-&gt;fact) {
<a name="line165">165: </a>      <A href="../../../../../../docs/manualpages/Viewer/PetscViewerASCIIPrintf.html#PetscViewerASCIIPrintf">PetscViewerASCIIPrintf</A>(viewer,<font color="#666666">"  Cholesky: factor fill ratio needed %G\n"</font>,lu-&gt;actualfill);
<a name="line166">166: </a>      <A href="../../../../../../docs/manualpages/Viewer/PetscViewerASCIIPrintf.html#PetscViewerASCIIPrintf">PetscViewerASCIIPrintf</A>(viewer,<font color="#666666">"       Factored matrix follows\n"</font>);
<a name="line167">167: </a>      <A href="../../../../../../docs/manualpages/Viewer/PetscViewerASCIIPushTab.html#PetscViewerASCIIPushTab">PetscViewerASCIIPushTab</A>(viewer);
<a name="line168">168: </a>      <A href="../../../../../../docs/manualpages/Viewer/PetscViewerASCIIPushTab.html#PetscViewerASCIIPushTab">PetscViewerASCIIPushTab</A>(viewer);
<a name="line169">169: </a>      <A href="../../../../../../docs/manualpages/Viewer/PetscViewerASCIIPushTab.html#PetscViewerASCIIPushTab">PetscViewerASCIIPushTab</A>(viewer);
<a name="line170">170: </a>      <A href="../../../../../../docs/manualpages/Viewer/PetscViewerPushFormat.html#PetscViewerPushFormat">PetscViewerPushFormat</A>(viewer,PETSC_VIEWER_ASCII_INFO);
<a name="line171">171: </a>      <A href="../../../../../../docs/manualpages/Mat/MatView.html#MatView">MatView</A>(lu-&gt;fact,viewer);
<a name="line172">172: </a>      <A href="../../../../../../docs/manualpages/Viewer/PetscViewerPopFormat.html#PetscViewerPopFormat">PetscViewerPopFormat</A>(viewer);
<a name="line173">173: </a>      <A href="../../../../../../docs/manualpages/Viewer/PetscViewerASCIIPopTab.html#PetscViewerASCIIPopTab">PetscViewerASCIIPopTab</A>(viewer);
<a name="line174">174: </a>      <A href="../../../../../../docs/manualpages/Viewer/PetscViewerASCIIPopTab.html#PetscViewerASCIIPopTab">PetscViewerASCIIPopTab</A>(viewer);
<a name="line175">175: </a>      <A href="../../../../../../docs/manualpages/Viewer/PetscViewerASCIIPopTab.html#PetscViewerASCIIPopTab">PetscViewerASCIIPopTab</A>(viewer);
<a name="line176">176: </a>    }
<a name="line177">177: </a>    <font color="#4169E1">if</font> (lu-&gt;reusefill)    {<A href="../../../../../../docs/manualpages/Viewer/PetscViewerASCIIPrintf.html#PetscViewerASCIIPrintf">PetscViewerASCIIPrintf</A>(viewer,<font color="#666666">"       Reusing fill from past factorization\n"</font>);}
<a name="line178">178: </a>    <font color="#4169E1">if</font> (lu-&gt;reuseordering) {<A href="../../../../../../docs/manualpages/Viewer/PetscViewerASCIIPrintf.html#PetscViewerASCIIPrintf">PetscViewerASCIIPrintf</A>(viewer,<font color="#666666">"       Reusing reordering from past factorization\n"</font>);}
<a name="line179">179: </a>  } <font color="#4169E1">else</font> <font color="#4169E1">if</font> (isstring) {
<a name="line180">180: </a>    <A href="../../../../../../docs/manualpages/Viewer/PetscViewerStringSPrintf.html#PetscViewerStringSPrintf">PetscViewerStringSPrintf</A>(viewer,<font color="#666666">" order=%s"</font>,lu-&gt;ordering);
<a name="line181">181: </a>  } <font color="#4169E1">else</font> {
<a name="line182">182: </a>    <A href="../../../../../../docs/manualpages/Sys/SETERRQ1.html#SETERRQ1">SETERRQ1</A>(PETSC_ERR_SUP,<font color="#666666">"Viewer type %s not supported for PCCHOLESKY"</font>,((<A href="../../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)viewer)-&gt;type_name);
<a name="line183">183: </a>  }
<a name="line184">184: </a>  <font color="#4169E1">return</font>(0);
<a name="line185">185: </a>}

<a name="line189">189: </a><strong><font color="#4169E1"><a name="PCGetFactoredMatrix_Cholesky"></a>static <A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> PCGetFactoredMatrix_Cholesky(<A href="../../../../../../docs/manualpages/PC/PC.html#PC">PC</A> pc,<A href="../../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> *mat)</font></strong>
<a name="line190">190: </a>{
<a name="line191">191: </a>  PC_Cholesky *dir = (PC_Cholesky*)pc-&gt;data;
<a name="line192">192: </a>
<a name="line194">194: </a>  <font color="#4169E1">if</font> (!dir-&gt;fact) <A href="../../../../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(PETSC_ERR_ORDER,<font color="#666666">"Matrix not yet factored; call after <A href="../../../../../../docs/manualpages/KSP/KSPSetUp.html#KSPSetUp">KSPSetUp</A>() or <A href="../../../../../../docs/manualpages/PC/PCSetUp.html#PCSetUp">PCSetUp</A>()"</font>);
<a name="line195">195: </a>  *mat = dir-&gt;fact;
<a name="line196">196: </a>  <font color="#4169E1">return</font>(0);
<a name="line197">197: </a>}

<a name="line201">201: </a><strong><font color="#4169E1"><a name="PCSetUp_Cholesky"></a>static <A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> PCSetUp_Cholesky(<A href="../../../../../../docs/manualpages/PC/PC.html#PC">PC</A> pc)</font></strong>
<a name="line202">202: </a>{
<a name="line204">204: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>     flg;
<a name="line205">205: </a>  PC_Cholesky    *dir = (PC_Cholesky*)pc-&gt;data;

<a name="line208">208: </a>  <font color="#4169E1">if</font> (dir-&gt;reusefill &amp;&amp; pc-&gt;setupcalled) dir-&gt;info.fill = dir-&gt;actualfill;
<a name="line209">209: </a>
<a name="line210">210: </a>  <font color="#4169E1">if</font> (dir-&gt;inplace) {
<a name="line211">211: </a>    <font color="#4169E1">if</font> (dir-&gt;row &amp;&amp; dir-&gt;col &amp;&amp; (dir-&gt;row != dir-&gt;col)) {
<a name="line212">212: </a>      <A href="../../../../../../docs/manualpages/IS/ISDestroy.html#ISDestroy">ISDestroy</A>(dir-&gt;row);
<a name="line213">213: </a>      dir-&gt;row = 0;
<a name="line214">214: </a>    }
<a name="line215">215: </a>    <font color="#4169E1">if</font> (dir-&gt;col) {
<a name="line216">216: </a>      <A href="../../../../../../docs/manualpages/IS/ISDestroy.html#ISDestroy">ISDestroy</A>(dir-&gt;col);
<a name="line217">217: </a>      dir-&gt;col = 0;
<a name="line218">218: </a>    }
<a name="line219">219: </a>    <A href="../../../../../../docs/manualpages/MatOrderings/MatGetOrdering.html#MatGetOrdering">MatGetOrdering</A>(pc-&gt;pmat,dir-&gt;ordering,&amp;dir-&gt;row,&amp;dir-&gt;col);
<a name="line220">220: </a>    <font color="#4169E1">if</font> (dir-&gt;col &amp;&amp; (dir-&gt;row != dir-&gt;col)) {  <font color="#B22222">/* only use row ordering for SBAIJ */</font>
<a name="line221">221: </a>      <A href="../../../../../../docs/manualpages/IS/ISDestroy.html#ISDestroy">ISDestroy</A>(dir-&gt;col);
<a name="line222">222: </a>      dir-&gt;col=0;
<a name="line223">223: </a>    }
<a name="line224">224: </a>    <font color="#4169E1">if</font> (dir-&gt;row) {PetscLogObjectParent(pc,dir-&gt;row);}
<a name="line225">225: </a>    <A href="../../../../../../docs/manualpages/Mat/MatCholeskyFactor.html#MatCholeskyFactor">MatCholeskyFactor</A>(pc-&gt;pmat,dir-&gt;row,&amp;dir-&gt;info);
<a name="line226">226: </a>    dir-&gt;fact = pc-&gt;pmat;
<a name="line227">227: </a>  } <font color="#4169E1">else</font> {
<a name="line228">228: </a>    <A href="../../../../../../docs/manualpages/Mat/MatInfo.html#MatInfo">MatInfo</A> info;
<a name="line229">229: </a>    <font color="#4169E1">if</font> (!pc-&gt;setupcalled) {
<a name="line230">230: </a>      <A href="../../../../../../docs/manualpages/MatOrderings/MatGetOrdering.html#MatGetOrdering">MatGetOrdering</A>(pc-&gt;pmat,dir-&gt;ordering,&amp;dir-&gt;row,&amp;dir-&gt;col);
<a name="line231">231: </a>      <font color="#B22222">/* check if dir-&gt;row == dir-&gt;col */</font>
<a name="line232">232: </a>      <A href="../../../../../../docs/manualpages/IS/ISEqual.html#ISEqual">ISEqual</A>(dir-&gt;row,dir-&gt;col,&amp;flg);
<a name="line233">233: </a>      <font color="#4169E1">if</font> (!flg) <A href="../../../../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(PETSC_ERR_ARG_INCOMP,<font color="#666666">"row and column permutations must equal"</font>);
<a name="line234">234: </a>      <A href="../../../../../../docs/manualpages/IS/ISDestroy.html#ISDestroy">ISDestroy</A>(dir-&gt;col); <font color="#B22222">/* only pass one ordering into CholeskyFactor */</font>
<a name="line235">235: </a>      dir-&gt;col=0;

<a name="line237">237: </a>      <A href="../../../../../../docs/manualpages/Sys/PetscOptionsHasName.html#PetscOptionsHasName">PetscOptionsHasName</A>(pc-&gt;prefix,<font color="#666666">"-pc_factor_nonzeros_along_diagonal"</font>,&amp;flg);
<a name="line238">238: </a>      <font color="#4169E1">if</font> (flg) {
<a name="line239">239: </a>        <A href="../../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> tol = 1.e-10;
<a name="line240">240: </a>        <A href="../../../../../../docs/manualpages/Sys/PetscOptionsGetReal.html#PetscOptionsGetReal">PetscOptionsGetReal</A>(pc-&gt;prefix,<font color="#666666">"-pc_factor_nonzeros_along_diagonal"</font>,&amp;tol,<A href="../../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line241">241: </a>        <A href="../../../../../../docs/manualpages/Mat/MatReorderForNonzeroDiagonal.html#MatReorderForNonzeroDiagonal">MatReorderForNonzeroDiagonal</A>(pc-&gt;pmat,tol,dir-&gt;row,dir-&gt;row);
<a name="line242">242: </a>      }
<a name="line243">243: </a>      <font color="#4169E1">if</font> (dir-&gt;row) {PetscLogObjectParent(pc,dir-&gt;row);}
<a name="line244">244: </a>      <A href="../../../../../../docs/manualpages/Mat/MatCholeskyFactorSymbolic.html#MatCholeskyFactorSymbolic">MatCholeskyFactorSymbolic</A>(pc-&gt;pmat,dir-&gt;row,&amp;dir-&gt;info,&amp;dir-&gt;fact);
<a name="line245">245: </a>      <A href="../../../../../../docs/manualpages/Mat/MatGetInfo.html#MatGetInfo">MatGetInfo</A>(dir-&gt;fact,MAT_LOCAL,&amp;info);
<a name="line246">246: </a>      dir-&gt;actualfill = info.fill_ratio_needed;
<a name="line247">247: </a>      PetscLogObjectParent(pc,dir-&gt;fact);
<a name="line248">248: </a>    } <font color="#4169E1">else</font> <font color="#4169E1">if</font> (pc-&gt;flag != SAME_NONZERO_PATTERN) {
<a name="line249">249: </a>      <font color="#4169E1">if</font> (!dir-&gt;reuseordering) {
<a name="line250">250: </a>        <font color="#4169E1">if</font> (dir-&gt;row &amp;&amp; dir-&gt;col &amp;&amp; (dir-&gt;row != dir-&gt;col)) {
<a name="line251">251: </a>          <A href="../../../../../../docs/manualpages/IS/ISDestroy.html#ISDestroy">ISDestroy</A>(dir-&gt;row);
<a name="line252">252: </a>          dir-&gt;row = 0;
<a name="line253">253: </a>        }
<a name="line254">254: </a>        <font color="#4169E1">if</font> (dir-&gt;col) {
<a name="line255">255: </a>          <A href="../../../../../../docs/manualpages/IS/ISDestroy.html#ISDestroy">ISDestroy</A>(dir-&gt;col);
<a name="line256">256: </a>          dir-&gt;col =0;
<a name="line257">257: </a>        }
<a name="line258">258: </a>        <A href="../../../../../../docs/manualpages/MatOrderings/MatGetOrdering.html#MatGetOrdering">MatGetOrdering</A>(pc-&gt;pmat,dir-&gt;ordering,&amp;dir-&gt;row,&amp;dir-&gt;col);
<a name="line259">259: </a>        <font color="#4169E1">if</font> (dir-&gt;col &amp;&amp; (dir-&gt;row != dir-&gt;col)) {  <font color="#B22222">/* only use row ordering for SBAIJ */</font>
<a name="line260">260: </a>          <A href="../../../../../../docs/manualpages/IS/ISDestroy.html#ISDestroy">ISDestroy</A>(dir-&gt;col);
<a name="line261">261: </a>          dir-&gt;col=0;
<a name="line262">262: </a>        }
<a name="line263">263: </a>        <A href="../../../../../../docs/manualpages/Sys/PetscOptionsHasName.html#PetscOptionsHasName">PetscOptionsHasName</A>(pc-&gt;prefix,<font color="#666666">"-pc_factor_nonzeros_along_diagonal"</font>,&amp;flg);
<a name="line264">264: </a>        <font color="#4169E1">if</font> (flg) {
<a name="line265">265: </a>          <A href="../../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> tol = 1.e-10;
<a name="line266">266: </a>          <A href="../../../../../../docs/manualpages/Sys/PetscOptionsGetReal.html#PetscOptionsGetReal">PetscOptionsGetReal</A>(pc-&gt;prefix,<font color="#666666">"-pc_factor_nonzeros_along_diagonal"</font>,&amp;tol,<A href="../../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line267">267: </a>          <A href="../../../../../../docs/manualpages/Mat/MatReorderForNonzeroDiagonal.html#MatReorderForNonzeroDiagonal">MatReorderForNonzeroDiagonal</A>(pc-&gt;pmat,tol,dir-&gt;row,dir-&gt;row);
<a name="line268">268: </a>        }
<a name="line269">269: </a>        <font color="#4169E1">if</font> (dir-&gt;row) {PetscLogObjectParent(pc,dir-&gt;row);}
<a name="line270">270: </a>      }
<a name="line271">271: </a>      <A href="../../../../../../docs/manualpages/Mat/MatDestroy.html#MatDestroy">MatDestroy</A>(dir-&gt;fact);
<a name="line272">272: </a>      <A href="../../../../../../docs/manualpages/Mat/MatCholeskyFactorSymbolic.html#MatCholeskyFactorSymbolic">MatCholeskyFactorSymbolic</A>(pc-&gt;pmat,dir-&gt;row,&amp;dir-&gt;info,&amp;dir-&gt;fact);
<a name="line273">273: </a>      <A href="../../../../../../docs/manualpages/Mat/MatGetInfo.html#MatGetInfo">MatGetInfo</A>(dir-&gt;fact,MAT_LOCAL,&amp;info);
<a name="line274">274: </a>      dir-&gt;actualfill = info.fill_ratio_needed;
<a name="line275">275: </a>      PetscLogObjectParent(pc,dir-&gt;fact);
<a name="line276">276: </a>    }
<a name="line277">277: </a>    <A href="../../../../../../docs/manualpages/Mat/MatCholeskyFactorNumeric.html#MatCholeskyFactorNumeric">MatCholeskyFactorNumeric</A>(pc-&gt;pmat,&amp;dir-&gt;info,&amp;dir-&gt;fact);
<a name="line278">278: </a>  }
<a name="line279">279: </a>  <font color="#4169E1">return</font>(0);
<a name="line280">280: </a>}

<a name="line284">284: </a><strong><font color="#4169E1"><a name="PCDestroy_Cholesky"></a>static <A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> PCDestroy_Cholesky(<A href="../../../../../../docs/manualpages/PC/PC.html#PC">PC</A> pc)</font></strong>
<a name="line285">285: </a>{
<a name="line286">286: </a>  PC_Cholesky    *dir = (PC_Cholesky*)pc-&gt;data;

<a name="line290">290: </a>  <font color="#4169E1">if</font> (!dir-&gt;inplace &amp;&amp; dir-&gt;fact) {<A href="../../../../../../docs/manualpages/Mat/MatDestroy.html#MatDestroy">MatDestroy</A>(dir-&gt;fact);}
<a name="line291">291: </a>  <font color="#4169E1">if</font> (dir-&gt;row) {<A href="../../../../../../docs/manualpages/IS/ISDestroy.html#ISDestroy">ISDestroy</A>(dir-&gt;row);}
<a name="line292">292: </a>  <font color="#4169E1">if</font> (dir-&gt;col) {<A href="../../../../../../docs/manualpages/IS/ISDestroy.html#ISDestroy">ISDestroy</A>(dir-&gt;col);}
<a name="line293">293: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscStrfree.html#PetscStrfree">PetscStrfree</A>(dir-&gt;ordering);
<a name="line294">294: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(dir);
<a name="line295">295: </a>  <font color="#4169E1">return</font>(0);
<a name="line296">296: </a>}

<a name="line300">300: </a><strong><font color="#4169E1"><a name="PCApply_Cholesky"></a>static <A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> PCApply_Cholesky(<A href="../../../../../../docs/manualpages/PC/PC.html#PC">PC</A> pc,<A href="../../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> x,<A href="../../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> y)</font></strong>
<a name="line301">301: </a>{
<a name="line302">302: </a>  PC_Cholesky    *dir = (PC_Cholesky*)pc-&gt;data;
<a name="line304">304: </a>
<a name="line306">306: </a>  <font color="#4169E1">if</font> (dir-&gt;inplace) {<A href="../../../../../../docs/manualpages/Mat/MatSolve.html#MatSolve">MatSolve</A>(pc-&gt;pmat,x,y);}
<a name="line307">307: </a>  <font color="#4169E1">else</font>              {<A href="../../../../../../docs/manualpages/Mat/MatSolve.html#MatSolve">MatSolve</A>(dir-&gt;fact,x,y);}
<a name="line308">308: </a>  <font color="#4169E1">return</font>(0);
<a name="line309">309: </a>}

<a name="line313">313: </a><strong><font color="#4169E1"><a name="PCApplyTranspose_Cholesky"></a>static <A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> PCApplyTranspose_Cholesky(<A href="../../../../../../docs/manualpages/PC/PC.html#PC">PC</A> pc,<A href="../../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> x,<A href="../../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> y)</font></strong>
<a name="line314">314: </a>{
<a name="line315">315: </a>  PC_Cholesky    *dir = (PC_Cholesky*)pc-&gt;data;

<a name="line319">319: </a>  <font color="#4169E1">if</font> (dir-&gt;inplace) {<A href="../../../../../../docs/manualpages/Mat/MatSolveTranspose.html#MatSolveTranspose">MatSolveTranspose</A>(pc-&gt;pmat,x,y);}
<a name="line320">320: </a>  <font color="#4169E1">else</font>              {<A href="../../../../../../docs/manualpages/Mat/MatSolveTranspose.html#MatSolveTranspose">MatSolveTranspose</A>(dir-&gt;fact,x,y);}
<a name="line321">321: </a>  <font color="#4169E1">return</font>(0);
<a name="line322">322: </a>}

<a name="line324">324: </a><font color="#B22222">/* -----------------------------------------------------------------------------------*/</font>

<a name="line329">329: </a><strong><font color="#4169E1"><a name="PCFactorSetFill_Cholesky"></a><A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  PCFactorSetFill_Cholesky(<A href="../../../../../../docs/manualpages/PC/PC.html#PC">PC</A> pc,<A href="../../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> fill)</font></strong>
<a name="line330">330: </a>{
<a name="line331">331: </a>  PC_Cholesky *dir;
<a name="line332">332: </a>
<a name="line334">334: </a>  dir = (PC_Cholesky*)pc-&gt;data;
<a name="line335">335: </a>  dir-&gt;info.fill = fill;
<a name="line336">336: </a>  <font color="#4169E1">return</font>(0);
<a name="line337">337: </a>}

<a name="line343">343: </a><strong><font color="#4169E1"><a name="PCFactorSetUseInPlace_Cholesky"></a><A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  PCFactorSetUseInPlace_Cholesky(<A href="../../../../../../docs/manualpages/PC/PC.html#PC">PC</A> pc)</font></strong>
<a name="line344">344: </a>{
<a name="line345">345: </a>  PC_Cholesky *dir;

<a name="line348">348: </a>  dir = (PC_Cholesky*)pc-&gt;data;
<a name="line349">349: </a>  dir-&gt;inplace = <A href="../../../../../../docs/manualpages/Sys/PETSC_TRUE.html#PETSC_TRUE">PETSC_TRUE</A>;
<a name="line350">350: </a>  <font color="#4169E1">return</font>(0);
<a name="line351">351: </a>}

<a name="line357">357: </a><strong><font color="#4169E1"><a name="PCFactorSetMatOrdering_Cholesky"></a><A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  PCFactorSetMatOrdering_Cholesky(<A href="../../../../../../docs/manualpages/PC/PC.html#PC">PC</A> pc,<A href="../../../../../../docs/manualpages/Mat/MatOrderingType.html#MatOrderingType">MatOrderingType</A> ordering)</font></strong>
<a name="line358">358: </a>{
<a name="line359">359: </a>  PC_Cholesky    *dir = (PC_Cholesky*)pc-&gt;data;

<a name="line363">363: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscStrfree.html#PetscStrfree">PetscStrfree</A>(dir-&gt;ordering);
<a name="line364">364: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscStrallocpy.html#PetscStrallocpy">PetscStrallocpy</A>(ordering,&amp;dir-&gt;ordering);
<a name="line365">365: </a>  <font color="#4169E1">return</font>(0);
<a name="line366">366: </a>}

<a name="line369">369: </a><font color="#B22222">/* -----------------------------------------------------------------------------------*/</font>

<a name="line373">373: </a><font color="#B22222">/*@</font>
<a name="line374">374: </a><font color="#B22222">   <A href="../../../../../../docs/manualpages/PC/PCFactorSetReuseOrdering.html#PCFactorSetReuseOrdering">PCFactorSetReuseOrdering</A> - When similar matrices are factored, this</font>
<a name="line375">375: </a><font color="#B22222">   causes the ordering computed in the first factor to be used for all</font>
<a name="line376">376: </a><font color="#B22222">   following factors.</font>

<a name="line378">378: </a><font color="#B22222">   Collective on <A href="../../../../../../docs/manualpages/PC/PC.html#PC">PC</A></font>

<a name="line380">380: </a><font color="#B22222">   Input Parameters:</font>
<a name="line381">381: </a><font color="#B22222">+  pc - the preconditioner context</font>
<a name="line382">382: </a><font color="#B22222">-  flag - <A href="../../../../../../docs/manualpages/Sys/PETSC_TRUE.html#PETSC_TRUE">PETSC_TRUE</A> to reuse else <A href="../../../../../../docs/manualpages/Sys/PETSC_FALSE.html#PETSC_FALSE">PETSC_FALSE</A></font>

<a name="line384">384: </a><font color="#B22222">   Options Database Key:</font>
<a name="line385">385: </a><font color="#B22222">.  -pc_factor_reuse_ordering - Activate <A href="../../../../../../docs/manualpages/PC/PCFactorSetReuseOrdering.html#PCFactorSetReuseOrdering">PCFactorSetReuseOrdering</A>()</font>

<a name="line387">387: </a><font color="#B22222">   Level: intermediate</font>

<a name="line389">389: </a><font color="#B22222">.keywords: <A href="../../../../../../docs/manualpages/PC/PC.html#PC">PC</A>, levels, reordering, factorization, incomplete, LU</font>

<a name="line391">391: </a><font color="#B22222">.seealso: <A href="../../../../../../docs/manualpages/PC/PCFactorSetReuseFill.html#PCFactorSetReuseFill">PCFactorSetReuseFill</A>()</font>
<a name="line392">392: </a><font color="#B22222">@*/</font>
<a name="line393">393: </a><strong><font color="#4169E1"><a name="PCFactorSetReuseOrdering"></a><A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  <A href="../../../../../../docs/manualpages/PC/PCFactorSetReuseOrdering.html#PCFactorSetReuseOrdering">PCFactorSetReuseOrdering</A>(<A href="../../../../../../docs/manualpages/PC/PC.html#PC">PC</A> pc,<A href="../../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A> flag)</font></strong>
<a name="line394">394: </a>{
<a name="line395">395: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> ierr,(*f)(<A href="../../../../../../docs/manualpages/PC/PC.html#PC">PC</A>,<A href="../../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>);

<a name="line399">399: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscObjectQueryFunction.html#PetscObjectQueryFunction">PetscObjectQueryFunction</A>((<A href="../../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)pc,<font color="#666666">"PCFactorSetReuseOrdering_C"</font>,(void (**)(void))&amp;f);
<a name="line400">400: </a>  <font color="#4169E1">if</font> (f) {
<a name="line401">401: </a>    (*f)(pc,flag);
<a name="line402">402: </a>  }
<a name="line403">403: </a>  <font color="#4169E1">return</font>(0);
<a name="line404">404: </a>}

<a name="line408">408: </a><font color="#B22222">/*@</font>
<a name="line409">409: </a><font color="#B22222">   <A href="../../../../../../docs/manualpages/PC/PCFactorSetReuseFill.html#PCFactorSetReuseFill">PCFactorSetReuseFill</A> - When matrices with same different nonzero structure are factored,</font>
<a name="line410">410: </a><font color="#B22222">   this causes later ones to use the fill ratio computed in the initial factorization.</font>

<a name="line412">412: </a><font color="#B22222">   Collective on <A href="../../../../../../docs/manualpages/PC/PC.html#PC">PC</A></font>

<a name="line414">414: </a><font color="#B22222">   Input Parameters:</font>
<a name="line415">415: </a><font color="#B22222">+  pc - the preconditioner context</font>
<a name="line416">416: </a><font color="#B22222">-  flag - <A href="../../../../../../docs/manualpages/Sys/PETSC_TRUE.html#PETSC_TRUE">PETSC_TRUE</A> to reuse else <A href="../../../../../../docs/manualpages/Sys/PETSC_FALSE.html#PETSC_FALSE">PETSC_FALSE</A></font>

<a name="line418">418: </a><font color="#B22222">   Options Database Key:</font>
<a name="line419">419: </a><font color="#B22222">.  -pc_factor_reuse_fill - Activates <A href="../../../../../../docs/manualpages/PC/PCFactorSetReuseFill.html#PCFactorSetReuseFill">PCFactorSetReuseFill</A>()</font>

<a name="line421">421: </a><font color="#B22222">   Level: intermediate</font>

<a name="line423">423: </a><font color="#B22222">.keywords: <A href="../../../../../../docs/manualpages/PC/PC.html#PC">PC</A>, levels, reordering, factorization, incomplete, Cholesky</font>

<a name="line425">425: </a><font color="#B22222">.seealso: <A href="../../../../../../docs/manualpages/PC/PCFactorSetReuseOrdering.html#PCFactorSetReuseOrdering">PCFactorSetReuseOrdering</A>()</font>
<a name="line426">426: </a><font color="#B22222">@*/</font>
<a name="line427">427: </a><strong><font color="#4169E1"><a name="PCFactorSetReuseFill"></a><A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  <A href="../../../../../../docs/manualpages/PC/PCFactorSetReuseFill.html#PCFactorSetReuseFill">PCFactorSetReuseFill</A>(<A href="../../../../../../docs/manualpages/PC/PC.html#PC">PC</A> pc,<A href="../../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A> flag)</font></strong>
<a name="line428">428: </a>{
<a name="line429">429: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> ierr,(*f)(<A href="../../../../../../docs/manualpages/PC/PC.html#PC">PC</A>,<A href="../../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>);

<a name="line433">433: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscObjectQueryFunction.html#PetscObjectQueryFunction">PetscObjectQueryFunction</A>((<A href="../../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)pc,<font color="#666666">"PCFactorSetReuseFill_C"</font>,(void (**)(void))&amp;f);
<a name="line434">434: </a>  <font color="#4169E1">if</font> (f) {
<a name="line435">435: </a>    (*f)(pc,flag);
<a name="line436">436: </a>  }
<a name="line437">437: </a>  <font color="#4169E1">return</font>(0);
<a name="line438">438: </a>}

<a name="line440">440: </a><font color="#B22222">/*MC</font>
<a name="line441">441: </a><font color="#B22222">   <A href="../../../../../../docs/manualpages/PC/PCCholesky.html#PCCholesky">PCCholesky</A> - Uses a direct solver, based on Cholesky factorization, as a preconditioner</font>

<a name="line443">443: </a><font color="#B22222">   Options Database Keys:</font>
<a name="line444">444: </a><font color="#B22222">+  -pc_factor_reuse_ordering - Activate <A href="../../../../../../docs/manualpages/PC/PCFactorSetReuseOrdering.html#PCFactorSetReuseOrdering">PCFactorSetReuseOrdering</A>()</font>
<a name="line445">445: </a><font color="#B22222">.  -pc_factor_reuse_fill - Activates <A href="../../../../../../docs/manualpages/PC/PCFactorSetReuseFill.html#PCFactorSetReuseFill">PCFactorSetReuseFill</A>()</font>
<a name="line446">446: </a><font color="#B22222">.  -pc_factor_fill &lt;fill&gt; - Sets fill amount</font>
<a name="line447">447: </a><font color="#B22222">.  -pc_factor_in_place - Activates in-place factorization</font>
<a name="line448">448: </a><font color="#B22222">.  -pc_factor_mat_ordering_type &lt;nd,rcm,...&gt; - Sets ordering routine</font>
<a name="line449">449: </a><font color="#B22222">.  -pc_factor_shift_nonzero &lt;shift&gt; - Sets shift amount or <A href="../../../../../../docs/manualpages/Sys/PETSC_DECIDE.html#PETSC_DECIDE">PETSC_DECIDE</A> for the default</font>
<a name="line450">450: </a><font color="#B22222">-  -pc_factor_shift_positive_definite [<A href="../../../../../../docs/manualpages/Sys/PETSC_TRUE.html#PETSC_TRUE">PETSC_TRUE</A>/<A href="../../../../../../docs/manualpages/Sys/PETSC_FALSE.html#PETSC_FALSE">PETSC_FALSE</A>] - Activate/Deactivate <A href="../../../../../../docs/manualpages/PC/PCFactorSetShiftPd.html#PCFactorSetShiftPd">PCFactorSetShiftPd</A>(); the value</font>
<a name="line451">451: </a><font color="#B22222">   is optional with <A href="../../../../../../docs/manualpages/Sys/PETSC_TRUE.html#PETSC_TRUE">PETSC_TRUE</A> being the default</font>

<a name="line453">453: </a><font color="#B22222">   Notes: Not all options work for all matrix formats</font>

<a name="line455">455: </a><font color="#B22222">   Level: beginner</font>

<a name="line457">457: </a><font color="#B22222">   Concepts: Cholesky factorization, direct solver</font>

<a name="line459">459: </a><font color="#B22222">   Notes: Usually this will compute an "exact" solution in one iteration and does </font>
<a name="line460">460: </a><font color="#B22222">          not need a Krylov method (i.e. you can use -ksp_type preonly, or </font>
<a name="line461">461: </a><font color="#B22222">          <A href="../../../../../../docs/manualpages/KSP/KSPSetType.html#KSPSetType">KSPSetType</A>(ksp,<A href="../../../../../../docs/manualpages/KSP/KSPPREONLY.html#KSPPREONLY">KSPPREONLY</A>) for the Krylov method</font>

<a name="line463">463: </a><font color="#B22222">.seealso:  <A href="../../../../../../docs/manualpages/PC/PCCreate.html#PCCreate">PCCreate</A>(), <A href="../../../../../../docs/manualpages/PC/PCSetType.html#PCSetType">PCSetType</A>(), <A href="../../../../../../docs/manualpages/PC/PCType.html#PCType">PCType</A> (for list of available types), <A href="../../../../../../docs/manualpages/PC/PC.html#PC">PC</A>,</font>
<a name="line464">464: </a><font color="#B22222">           <A href="../../../../../../docs/manualpages/PC/PCILU.html#PCILU">PCILU</A>, <A href="../../../../../../docs/manualpages/PC/PCLU.html#PCLU">PCLU</A>, <A href="../../../../../../docs/manualpages/PC/PCICC.html#PCICC">PCICC</A>, <A href="../../../../../../docs/manualpages/PC/PCFactorSetReuseOrdering.html#PCFactorSetReuseOrdering">PCFactorSetReuseOrdering</A>(), <A href="../../../../../../docs/manualpages/PC/PCFactorSetReuseFill.html#PCFactorSetReuseFill">PCFactorSetReuseFill</A>(), <A href="../../../../../../docs/manualpages/PC/PCGetFactoredMatrix.html#PCGetFactoredMatrix">PCGetFactoredMatrix</A>(),</font>
<a name="line465">465: </a><font color="#B22222">           <A href="../../../../../../docs/manualpages/PC/PCFactorSetFill.html#PCFactorSetFill">PCFactorSetFill</A>(), <A href="../../../../../../docs/manualpages/PC/PCFactorSetShiftNonzero.html#PCFactorSetShiftNonzero">PCFactorSetShiftNonzero</A>(), <A href="../../../../../../docs/manualpages/PC/PCFactorSetShiftPd.html#PCFactorSetShiftPd">PCFactorSetShiftPd</A>(),</font>
<a name="line466">466: </a><font color="#B22222">           <A href="../../../../../../docs/manualpages/PC/PCFactorSetUseInPlace.html#PCFactorSetUseInPlace">PCFactorSetUseInPlace</A>(), <A href="../../../../../../docs/manualpages/PC/PCFactorSetMatOrdering.html#PCFactorSetMatOrdering">PCFactorSetMatOrdering</A>(),<A href="../../../../../../docs/manualpages/PC/PCFactorSetShiftNonzero.html#PCFactorSetShiftNonzero">PCFactorSetShiftNonzero</A>(),<A href="../../../../../../docs/manualpages/PC/PCFactorSetShiftPd.html#PCFactorSetShiftPd">PCFactorSetShiftPd</A>()</font>

<a name="line468">468: </a><font color="#B22222">M*/</font>

<a name="line473">473: </a><strong><font color="#4169E1"><a name="PCCreate_Cholesky"></a><A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  PCCreate_Cholesky(<A href="../../../../../../docs/manualpages/PC/PC.html#PC">PC</A> pc)</font></strong>
<a name="line474">474: </a>{
<a name="line476">476: </a>  PC_Cholesky    *dir;

<a name="line479">479: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscNew.html#PetscNew">PetscNew</A>(PC_Cholesky,&amp;dir);
<a name="line480">480: </a>  PetscLogObjectMemory(pc,<font color="#4169E1">sizeof</font>(PC_Cholesky));

<a name="line482">482: </a>  dir-&gt;fact                   = 0;
<a name="line483">483: </a>  dir-&gt;inplace                = <A href="../../../../../../docs/manualpages/Sys/PETSC_FALSE.html#PETSC_FALSE">PETSC_FALSE</A>;
<a name="line484">484: </a>  <A href="../../../../../../docs/manualpages/Mat/MatFactorInfoInitialize.html#MatFactorInfoInitialize">MatFactorInfoInitialize</A>(&amp;dir-&gt;info);
<a name="line485">485: </a>  dir-&gt;info.fill              = 5.0;
<a name="line486">486: </a>  dir-&gt;info.shiftnz           = 0.0;
<a name="line487">487: </a>  dir-&gt;info.shiftpd           = 0.0; <font color="#B22222">/* false */</font>
<a name="line488">488: </a>  dir-&gt;info.shift_fraction    = 0.0;
<a name="line489">489: </a>  dir-&gt;info.pivotinblocks     = 1.0;
<a name="line490">490: </a>  dir-&gt;col                    = 0;
<a name="line491">491: </a>  dir-&gt;row                    = 0;
<a name="line492">492: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscStrallocpy.html#PetscStrallocpy">PetscStrallocpy</A>(MATORDERING_NATURAL,&amp;dir-&gt;ordering);
<a name="line493">493: </a>  dir-&gt;reusefill        = <A href="../../../../../../docs/manualpages/Sys/PETSC_FALSE.html#PETSC_FALSE">PETSC_FALSE</A>;
<a name="line494">494: </a>  dir-&gt;reuseordering    = <A href="../../../../../../docs/manualpages/Sys/PETSC_FALSE.html#PETSC_FALSE">PETSC_FALSE</A>;
<a name="line495">495: </a>  pc-&gt;data              = (void*)dir;

<a name="line497">497: </a>  pc-&gt;ops-&gt;destroy           = PCDestroy_Cholesky;
<a name="line498">498: </a>  pc-&gt;ops-&gt;apply             = PCApply_Cholesky;
<a name="line499">499: </a>  pc-&gt;ops-&gt;applytranspose    = PCApplyTranspose_Cholesky;
<a name="line500">500: </a>  pc-&gt;ops-&gt;setup             = PCSetUp_Cholesky;
<a name="line501">501: </a>  pc-&gt;ops-&gt;setfromoptions    = PCSetFromOptions_Cholesky;
<a name="line502">502: </a>  pc-&gt;ops-&gt;view              = PCView_Cholesky;
<a name="line503">503: </a>  pc-&gt;ops-&gt;applyrichardson   = 0;
<a name="line504">504: </a>  pc-&gt;ops-&gt;getfactoredmatrix = PCGetFactoredMatrix_Cholesky;

<a name="line506">506: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscObjectComposeFunctionDynamic.html#PetscObjectComposeFunctionDynamic">PetscObjectComposeFunctionDynamic</A>((<A href="../../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)pc,<font color="#666666">"PCFactorSetZeroPivot_C"</font>,<font color="#666666">"PCFactorSetZeroPivot_Cholesky"</font>,
<a name="line507">507: </a>                    PCFactorSetZeroPivot_Cholesky);
<a name="line508">508: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscObjectComposeFunctionDynamic.html#PetscObjectComposeFunctionDynamic">PetscObjectComposeFunctionDynamic</A>((<A href="../../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)pc,<font color="#666666">"PCFactorSetShiftNonzero_C"</font>,<font color="#666666">"PCFactorSetShiftNonzero_Cholesky"</font>,
<a name="line509">509: </a>                    PCFactorSetShiftNonzero_Cholesky);
<a name="line510">510: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscObjectComposeFunctionDynamic.html#PetscObjectComposeFunctionDynamic">PetscObjectComposeFunctionDynamic</A>((<A href="../../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)pc,<font color="#666666">"PCFactorSetShiftPd_C"</font>,<font color="#666666">"PCFactorSetShiftPd_Cholesky"</font>,
<a name="line511">511: </a>                    PCFactorSetShiftPd_Cholesky);

<a name="line513">513: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscObjectComposeFunctionDynamic.html#PetscObjectComposeFunctionDynamic">PetscObjectComposeFunctionDynamic</A>((<A href="../../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)pc,<font color="#666666">"PCFactorSetFill_C"</font>,<font color="#666666">"PCFactorSetFill_Cholesky"</font>,
<a name="line514">514: </a>                    PCFactorSetFill_Cholesky);
<a name="line515">515: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscObjectComposeFunctionDynamic.html#PetscObjectComposeFunctionDynamic">PetscObjectComposeFunctionDynamic</A>((<A href="../../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)pc,<font color="#666666">"PCFactorSetUseInPlace_C"</font>,<font color="#666666">"PCFactorSetUseInPlace_Cholesky"</font>,
<a name="line516">516: </a>                    PCFactorSetUseInPlace_Cholesky);
<a name="line517">517: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscObjectComposeFunctionDynamic.html#PetscObjectComposeFunctionDynamic">PetscObjectComposeFunctionDynamic</A>((<A href="../../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)pc,<font color="#666666">"PCFactorSetMatOrdering_C"</font>,<font color="#666666">"PCFactorSetMatOrdering_Cholesky"</font>,
<a name="line518">518: </a>                    PCFactorSetMatOrdering_Cholesky);
<a name="line519">519: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscObjectComposeFunctionDynamic.html#PetscObjectComposeFunctionDynamic">PetscObjectComposeFunctionDynamic</A>((<A href="../../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)pc,<font color="#666666">"PCFactorSetReuseOrdering_C"</font>,<font color="#666666">"PCFactorSetReuseOrdering_Cholesky"</font>,
<a name="line520">520: </a>                    PCFactorSetReuseOrdering_Cholesky);
<a name="line521">521: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscObjectComposeFunctionDynamic.html#PetscObjectComposeFunctionDynamic">PetscObjectComposeFunctionDynamic</A>((<A href="../../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)pc,<font color="#666666">"PCFactorSetReuseFill_C"</font>,<font color="#666666">"PCFactorSetReuseFill_Cholesky"</font>,
<a name="line522">522: </a>                    PCFactorSetReuseFill_Cholesky);
<a name="line523">523: </a>  <font color="#4169E1">return</font>(0);
<a name="line524">524: </a>}
</pre>
</body>

</html>
